% show a random image from the preprocessed matrices from 
% The German Traffic Sign Benchmark (GTSRB)
% http://benchmark.ini.rub.de/?section=gtsrb&subsection=dataset

if ~exist('gtsrb_test', 'var')
  load('gtsrb_test.mat');
end

% show a random sign from the test set

ix = randi(length(gtsrb_test));

input = gtsrb_test(ix, :);
img = reshape(input(2:end), [30 30])';
subplot(1,2,1);
imagesc(img);
xlabel(sprintf('test(%d, 1) = %d', ix, input(1)));
axis("image");
colormap("gray");
subplot(1,2,2);
ref = imread(sprintf("signs/%d.jpg", input(1)));
image(ref);
axis("image");

