#include <string>
#include <cstdio>
#include <dlib/matrix.h>
#include "load_images.h"

void load_images(std::string image_path,
                 std::string label_path,
                 int count,
                 std::vector<dlib::matrix<uint8_t>> &image_vector,
                 std::vector<unsigned long> &label_vector
                 ) {

    const int HEIGHT = 30, WIDTH = 30;
    int k;

    // --- read images ---

    FILE *image_file = fopen(image_path.c_str(), "r");
    if (image_file == nullptr) {
        perror("unable to open image_path");
        exit(1);
    }

    image_vector.clear();
    for (k = 0; k < count; k++ ) {
        uint8_t buf[HEIGHT * WIDTH];
        int num = fread(buf, sizeof(uint8_t), HEIGHT * WIDTH, image_file);
        if (num != HEIGHT * WIDTH) {
            perror("failed to read from image_path");
            exit(1);

        }
        image_vector.push_back(dlib::mat(buf, HEIGHT, WIDTH));
    }

    fclose(image_file);

    // --- read labels ---

    FILE *label_file = fopen(label_path.c_str(), "r");
    if (label_file == nullptr) {
        perror("unable to open label_path");
        exit(1);

    }

    label_vector.clear();
    for (k = 0; k < count; k++ ) {
        uint64_t label;
        int num = fread(&label, sizeof(uint64_t), 1, label_file);
        if (num != 1) {
            perror("failed to read from label_path");
            exit(1);

        }
        label_vector.push_back(label);
    }

    fclose(label_file);

}